package searchfc;
#%###################################################
# Retourne si la ligne est un commentaire fortran
sub Fortran_Comment {
    local($ligne)=@_;
    if (( $ligne =~ /^[^\s]/i) && ( $ligne =~ /^[^\d]/i)) {
	return 1; # valeur true
    } else {
	$main::instruction = $ligne ;
	return 0; # valeur false
    }
}
#|#######################################################
sub Find_Parenthesis {
    local($paren,$instruction)=@_;
    local($end_paren)=0;
    unless ($instruction) { return ($paren,0,0); }
    while ( $instruction =~ /(.*?)(\(|\))(.*)/ ) { # parenthese: complet
	if ($3) { $instruction = $3 ;} else { $instruction = 0; };
	if ($end_paren) { $end_paren .= $1.$2; } else { $end_paren = $1.$2; };
	$parenmoved=1;
	if ($2 eq ')') {
	    $paren=$paren-1;
	} elsif ($2 eq '(') {
	    $paren=$paren+1;
	} else {
	    die "Search Parenthesis Lethal Error";
	}
	if ($paren == 1) { return ($paren,1,$end_paren); }
    }
    return ($paren,0,$end_paren);
}
#|#######################################################
sub Find_Parenthesis_Old {
    local($paren,$instruction)=@_;
    local($there_remains)=1;
    local($parenmoved)=0;
    while ( $instruction =~ /(.*)\((.*)\)(.*)/ ) { # parenthese: complet
	$instruction = $1.$2.$3 ;
	$there_remains++;
	$parenmoved=1;
    }
    while ($there_remains) {
	if ( $instruction =~ /(.*)\)(.*)/ ) { # fin de parenthese
	    $instruction = $1.$2 ;
	    $paren=$paren-1;
	    $parenmoved=1;
	} elsif ( $instruction =~ /(.*)\((.*)/ ) { # debut de parenthese
	    $instruction = $1.$2 ;
	    $paren++;
	    $parenmoved=1;
	} else { # a mettre en resultat
	    $there_remains = 0 ;
	}
    }
    return ($paren,$parenmoved);
}
#%###################################################
# Enlever les commentaires du C
sub C_Instruction_Commentaire {
# Attention:
# Les variables instruction et commentaire sont globales !!!
    local($comm,$ligne)=@_;
    local($r)=$ligne;
    local($i,$c,$left,$p)=("","","","");
    $ligne="";
    while ( $r =~ /(.*?)(\/\*|\*\/|\/\/)(.*)/ ) {
	$left=$1 ; $p=$2; $r=$3;
	$ligne .= $left ;
	if ($comm) {
	    $c .= $left ;
	    if ($p eq '*/') { # fin de commentaire, dbut code
		$comm=0;
#|		$ligne .= $p."$END_COMMENT"."$START_CODE";
		$ligne .= "$END_COMMENT"."$START_CODE";
	    }
	} else {
	    $i .= $left ;
	    if ($p eq '*/') {
		die "Terminating Comment in Instruction $file $.";
	    } elsif ($p eq '/*') {
#|		$ligne .= "$END_CODE"."$START_COMMENT".$p ;
		$ligne .= "$END_CODE"."$START_COMMENT" ;
		$comm=1;
	    } elsif ($p eq '//') {
#|		$ligne .= "$END_CODE"."$START_COMMENT".$p.$r."$END_COMMENT"."$START_CODE";
		$ligne .= "$END_CODE"."$START_COMMENT".$r."$END_COMMENT"."$START_CODE";
		$c .= $r ;
		$comm=0;
		$r="";
		last ;
	    }
	}
    }
    if ($r) {
	if ($comm) {
	    $c .= $r ;
	} else {
	    $i .= $r ;
	}
	$ligne .= $r ;
    }
    $main::instruction .= $i;
    $main::commentaire .= $c;
    return($comm,$ligne);
}
#|#######################################################
sub C_Accolade {
    local($acco,$instruction)=@_;
    local($there_remains)=1;
    local($accomoved)=0;
    while ( $instruction =~ /(.*)\{(.*)\}(.*)/ ) { # accolade: complet
	$instruction = $1.$2.$3 ;
	$there_remains++;
	$accomoved=1;
    }
    while ($there_remains) {
	if ( $instruction =~ /(.*)\}(.*)/ ) { # fin d'accolade
	    $instruction = $1.$2 ;
	    $acco=$acco-1;
	    $accomoved=1;
	} elsif ( $instruction =~ /(.*)\{(.*)/ ) { # debut d'accolade
	    $instruction = $1.$2 ;
	    $acco++;
	    $accomoved=1;
	} else { # a mettre en resultat
	    $there_remains = 0 ;
	}
    }
    return ($acco,$accomoved);
}
1;
